//---------------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#include <vcl\vcl.h>
#include <vcl\Registry.hpp>
#include <Printers.hpp>
#pragma hdrstop

#include "Main.h"
#include "About.h"
#include "SelNIC.h"
#include "CapFilter.h"
#include "MonPack.h"
#include "OptionSetting.h"
#include "ColorSetting.h"
#include "Proto.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner), Capturing(false), AsyncMode(true), ParamInterval(1000),
	  ParamBuffSize(8192 * 1024), DumpWidth(4), LastFocused(NULL),
          CaptureEventRecver(NULL)
{
	ListLastSelected = -1;
	TreeLastSelected = NULL;
	MacList = new TStringList;
	IPAddrList = new TStringList;
	ProtList = new TStringList;
	ListPacket = new TList;
	DumpList = new TStringList;
	Color[COLOR_DUMP] = clBlack;
	Color[COLOR_MACH] = clTeal;
	Color[COLOR_PROTO] = clNavy;
	Color[COLOR_IP] = clBlack;


	TRegistry* reg = new TRegistry;
	if (reg->OpenKey("Software\\arton\\FreeCap", true))
	{
		try
		{
			Height = reg->ReadInteger("FormHeight");
			Width = reg->ReadInteger("FormWidth");
			Left = reg->ReadInteger("FormLeft");
			Top = reg->ReadInteger("FormTop");
			ListView->Height = reg->ReadInteger("ListViewHeight");
			TreeView->Width = reg->ReadInteger("TreeViewWidth");
			bool b = reg->ReadBool("ListView");
			if (b == false)
			{
				ListView->Visible = b;
				DispListItem->Checked = b;
			}
			b = reg->ReadBool("TreeView");
			if (b == false)
			{
				TreeView->Visible = b;
				DispTreeItem->Checked = b;
				ChangeExpandButtons(b);
			}
			short asW[9];
			reg->ReadBinaryData("ListCols", asW, sizeof(short) * 9);
			for (int i = 0; i < 9; i++)
			{
				ListView->Columns->Items[i]->Width = asW[i];
			}
			ParamInterval = reg->ReadInteger("Interval");
			ParamBuffSize = reg->ReadInteger("BufferSize")  * 1024 * 1024;
			DumpWidth = reg->ReadInteger("DumpWidth");

		}
		catch (TObject* p)
		{
                        ;
		}
                reg->CloseKey();
      	}
	if (reg->OpenKey("Software\\arton\\FreeCap\\Font", true))
	{
		TFont* p = DumpView->Font;
		try
		{
			p->Height = reg->ReadInteger("Height");
			p->Name = reg->ReadString("Name");
			p->Pitch = (TFontPitch)reg->ReadInteger("Pitch");
			p->Size = reg->ReadInteger("Size");
		}
		catch (TObject* p)
		{
                        ;
		}
       		reg->CloseKey();
	}
	static char* asValName[] = { "Dump", "MACH", "PROTO", "IP", };
	if (reg->OpenKey("Software\\arton\\FreeCap\\Color", true))
	{
		try
		{
			for (int i = 0; i < COLOR_MAX; i++)
				Color[i] = (TColor)reg->ReadInteger(asValName[i]);
		}
		catch (TObject* p)
		{
                        ;
		}
       		reg->CloseKey();
	}
	delete reg;

        CaptureEventRecver = new DMacCaptureEvent;
	CaptureEventRecver->Parent = this;
	Application->OnHint = ShowHint;
	Application->OnIdle = OnIdle;
	HRESULT hr = CoCreateInstance(CLSID_MacCapture, NULL, CLSCTX_INPROC_SERVER,
		IID_IMacCapture, (void**)&MacCapture);
	if (hr != S_OK)
	{
		char sz[52];
		wsprintf(sz, "Capture Engine Creation Failure (%08X)", hr);
		Application->MessageBox(sz, Caption.c_str(), MB_OK);
		MacCapture = NULL;
		PostMessage(Handle, WM_CLOSE, 0, 0);
	}
	else
	{
		MacCapture->set_BufferSize(ParamBuffSize);
		MacCapture->set_MonitorEventInterval(ParamInterval);
		TStringList* pList = new TStringList;
		IAdapterCollection* pAdapters;
		if (MacCapture->get_Adapters(&pAdapters) == S_OK)
		{
			IUnknown* pUnk;
			if (pAdapters->get__NewEnum(&pUnk) == S_OK)
			{
				IEnumVARIANT* pEnum;
				if (pUnk->QueryInterface(IID_IEnumVARIANT, (void**)&pEnum) == S_OK)
				{
					VARIANT v;
					VariantInit(&v);
					ULONG ulFetch;
					while (pEnum->Next(1, &v, &ulFetch) == S_OK)
					{
						if (v.vt == VT_BSTR)
							pList->Add(OleStrToString(v.bstrVal));
						VariantClear(&v);
					}
					pEnum->Release();
				}
				pUnk->Release();
			}
			pAdapters->Release();
		}
		int SelIndex(0);
		if (pList->Count > 1)
		{
			Application->CreateForm(__classid(TSelNICDlg), &SelNICDlg);
			SelNICDlg->ListBox->Items->AddStrings(pList);
			SelIndex = -1;
			if (SelNICDlg->ShowModal() == IDOK)
			{
				SelIndex = SelNICDlg->SelectIndex;
			}
			delete SelNICDlg;

		}
		if (SelIndex >= 0)
		{
			AnsiString as = pList->Strings[SelIndex];
			StatusLine->Panels->Items[SL_NIC]->Text = "NIC: " + as.SubString(as.Pos("_") + 1, as.Length());
			BSTR bstr = StringToOleStr(as);
			MacCapture->Open(bstr);
			SysFreeString(bstr);
		}
		else
		{
			PostMessage(Handle, WM_CLOSE, 0, 0);
			return;
		}
		delete pList;
		VARIANT v;
		VariantInit(&v);
		if (MacCapture->get_MACAddress(&v) == S_OK)
		{
			if (v.vt == (VT_ARRAY | VT_UI1))
			{
				char sz[32];
				SafeArrayLock(v.parray);
				LPBYTE pb = (LPBYTE)v.parray->pvData;
				wsprintf(sz, "MAC: %02X-%02X-%02X-%02X-%02X-%02X",
					*pb, *(pb + 1), *(pb + 2), *(pb + 3), *(pb + 4), *(pb + 5));
				StatusLine->Panels->Items[SL_MAC]->Text = sz;
				SafeArrayUnlock(v.parray);
			}
			VariantClear(&v);
		}
		IConnectionPointContainer* pConnPt;
		if (MacCapture->QueryInterface(IID_IConnectionPointContainer, (void**)&pConnPt) == S_OK)
		{
			IConnectionPoint* pConn;

			if (pConnPt->FindConnectionPoint(DIID__IMacCaptureEvents, &pConn) == S_OK)
			{
				if (pConn->Advise(CaptureEventRecver, &dwCookie) == S_OK)
					AsyncMode = false;
				pConn->Release();
			}
			pConnPt->Release();
		}
	}
	// Command Line Processing
	LPTSTR psz = GetCommandLine();
	if (*psz != _T('"'))
	{
		while (*psz && !isspace(*psz)) psz++;
	}
	else
	{
		psz++;
		while (*psz && *psz != _T('"')) psz++;
		if (*psz == _T('"')) psz++;
	}
	while (*psz && isspace(*psz))
	{
		psz++;
	}
	if (*psz)
	{
		long lResult;
		BSTR bstr = StringToOleStr(psz);
		if (MacCapture->LoadData(bstr, &lResult) == S_OK && lResult == 0)
		{
			InitNew();
			SetIndex(psz);
		}
		SysFreeString(bstr);
	}
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::ShowHint(TObject *Sender)
{
	StatusLine->Panels->Items[0]->Text = Application->Hint;
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::OnIdle(TObject* Sender, bool& Done)
{
	CoFreeUnusedLibraries();
	if (DumpView->Focused())
	{
		ChangeMoveButtons(false);
	}
	else
	{
		if (ListPacket->Count > 0)
		{
			ListDownButton->Enabled = true;
			ListUpButton->Enabled = true;
		}
		if (TreeView->Visible == false || ListView->Visible == false)
			SyncButton->Enabled = false;
		else
			SyncButton->Enabled = true;
	}
	Done = true;
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::FileNew(TObject *Sender)
{
	//--- t@CVK쐬p̃R[hLq ---
	if (Capturing == false)
	{
		Application->CreateForm(__classid(TCapFilterDlg), &CapFilterDlg);
		CapFilterDlg->SetLists(MacList, IPAddrList, ProtList);
		if (CapFilterDlg->ShowModal() == mrOk)
		{
			MacCapture->RemoveFilters();
			if (MacList->Count || IPAddrList->Count || ProtList->Count)
			{
				int i;
				for (i = 0; i < MacList->Count; i++)
				{
					MacCapture->AddFilter((IFilterParam*)MacList->Objects[i]);
				}
				for (i = 0; i < IPAddrList->Count; i++)
				{
					MacCapture->AddFilter((IFilterParam*)IPAddrList->Objects[i]);
				}
				for (i = 0; i < ProtList->Count; i++)
				{
					MacCapture->AddFilter((IFilterParam*)ProtList->Objects[i]);
				}
			}
			Capturing = true;
			InitNew();
			StatusLine->Panels->Items[SL_STAT]->Text = "Capturing...";
			MonPackForm->InitNew(ParamInterval);
			if (AsyncMode == false)
			{
				Hide();
				for (int i = 0; i < COUNTOF(ATicks); i++) ATicks[i] = 0;
				MonPackForm->Show();
				Bytes = Packets = TicksCount = Ticks = 0;
			}
			MacCapture->Start((AsyncMode) ? VARIANT_FALSE : VARIANT_TRUE);
			if (AsyncMode == false)
			{
				Capturing = false;
				MonPackForm->Hide();
				Show();
				StatusLine->Panels->Items[SL_STAT]->Text = "Reading...";
				SetIndex();
			}
		}
		delete CapFilterDlg;
	}
	else
	{
		if (MacCapture->Stop() == S_OK)
		{
			Capturing = false;
			SetIndex();
		}
	}
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::FileOpen(TObject *Sender)
{
	if (OpenDialog->Execute())
	{
		//---- OpenDialog->FileName t@CƂăt@CJ
		//     R[hLq ----
		StatusLine->Panels->Items[SL_STAT]->Text = "Reading...";
		long lResult;
		BSTR bstr = StringToOleStr(OpenDialog->FileName);
		if (MacCapture->LoadData(bstr, &lResult) == S_OK && lResult == 0)
		{
			InitNew();
			SetIndex(OpenDialog->FileName.c_str());
		}
		SysFreeString(bstr);
	}
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::FileSaveAs(TObject *Sender)
{
	if (SaveDialog->Execute())
	{
		//--- ݂̃t@C SaveDialog->FileName ƂOŕۑ
		//    R[hLq ---
		AnsiString saveStat = StatusLine->Panels->Items[SL_STAT]->Text;
		AnsiString& as = SaveDialog->FileName;
		AnsiString ext;
		if (as.Length() > 4)
			ext = as.SubString(as.Length() - 2, 3);
		if (ext.AnsiCompareIC("TXT") == 0)
		{
			try
			{
				TFileStream* Stm = new TFileStream(SaveDialog->FileName, fmCreate | fmShareDenyWrite);
				TTreeNode* Root = TreeView->Items->GetFirstNode();
				int packets = Root->Count;
				for (int nd = 0; nd < packets; nd++)
				{
					DumpList->Clear();
					if (nd % 20 == 0)
					{
						char sz[64];
						wsprintf(sz, "Writing...%d/%d", nd, packets);
						StatusLine->Panels->Items[SL_STAT]->Text = sz;
					}
					if (nd != 0)
						DumpList->Append(AnsiString::StringOfChar('-', 80));

					IMacPacket* pPacket = (IMacPacket*)ListPacket->Items[nd];
					if (pPacket)
					{
						VARIANT v;
						VariantInit(&v);
						if (pPacket->get_Value(&v) == S_OK && v.vt == (VT_ARRAY | VT_UI1))
						{
							SafeArrayLock(v.parray);
							PrintFile(Root->Item[nd], pPacket, v.parray);
							DumpList->SaveToStream(Stm);
							SafeArrayUnlock(v.parray);
						}
						VariantClear(&v);
					}
				}
				delete Stm;
			}
			catch (TObject* p)
			{
                                ;
			}
		}
		else if (ext.AnsiCompareIC("CSV") == 0)
		{
			static const char szTitle[] = "M,MԊu,MACAhX,MMACAhX,t[^Cv,t[,MIPAhX,IPAhX,vgR\r\n";
			try
			{
				TFileStream* Stm = new TFileStream(SaveDialog->FileName, fmCreate | fmShareDenyWrite);
				Stm->Write(szTitle, sizeof(szTitle) - 1);	// -1 for NULL Terminator
				TListItems* Root = ListView->Items;
				int packets = Root->Count;
				for (int item = 0; item < packets; item++)
				{
					TListItem* pItem = Root->Item[item];
					AnsiString as(pItem->Caption.SubString(1, 8));
					as += "," + pItem->SubItems->CommaText;
					Stm->Write(as.c_str(), as.Length());
					Stm->Write("\r\n", 2);
				}
				delete Stm;
			}
			catch (TObject* p)
			{
				;
			}
		}
		else
		{
			long lResult;
			BSTR bstr = StringToOleStr(as);
			MacCapture->SaveData(bstr, &lResult);
			SysFreeString(bstr);
		}
		StatusLine->Panels->Items[SL_STAT]->Text = saveStat;
	}
}
//----------------------------------------------------------------------------
void TMainForm::PrintFile(TTreeNode* Node, IMacPacket* pPacket, SAFEARRAY* parray)
{
	if (Node->Level == 1) // MAC Level
	{
		PrintMACInfo(pPacket, parray);
	}
	else if (Node->Level == 2)	// Protocol Level
	{
		PrintPacketLevel(pPacket, parray);
	}
	else if (Node->Level == 3)	// IP only (IP Sub protocol Level)
	{
		int rest(0);
		LPBYTE pbRest;
		PrintIPLevel(pPacket, parray, rest, pbRest);
		if (rest)
		{
			char sz[64];
			wsprintf(sz, "User Data: (%dbytes)", rest);
			DumpList->Append(sz);
			DumpData(pbRest, rest, 0);
		}
	}
	for (int i = 0; i < Node->Count; i++)
	{
		PrintFile(Node->Item[i], pPacket, parray);	// recursive call;
	}
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::FilePrint(TObject *Sender)
{
	if (PrintDialog->Execute())
	{
		//---- ݂̃t@CR[hLq ----
		Printer()->Title = "FreeCap";
		DumpView->Print("FreeCap");
	}
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::FilePrintSetup(TObject *Sender)
{
	PrintSetupDialog->Execute();
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::FileExit(TObject *Sender)
{
	Close();
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::EditCopy(TObject *Sender)
{
	//--- I𕔕Rs[R[hLq ----
	if (DumpView->SelLength <= 0)
	{
		DumpView->SelectAll();
		DumpView->CopyToClipboard();
		DumpView->SelLength = 0;
	}
	else
	{
		DumpView->CopyToClipboard();
	}
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::HelpContents(TObject *Sender)
{
	Application->HelpCommand(HELP_CONTENTS, 0);
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::HelpSearch(TObject *Sender)
{
	Application->HelpCommand(HELP_PARTIALKEY, Longint(""));
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::HelpAbout(TObject *Sender)
{
	//---- vÕo[W\R[hLq ----
	Application->CreateForm(__classid(TAboutBox), &AboutBox);
	AboutBox->ShowModal();
	delete AboutBox;
}
//----------------------------------------------------------------------------
// User Codes
//----------------------------------------------------------------------------
void TMainForm::SetIndex(char* pName)
{
	NoUpdate = true;
	TreeView->Items->BeginUpdate();
	ListView->Items->BeginUpdate();
	IPacketCollection* pColl;
	if (MacCapture->get_Packets(&pColl) == S_OK)
	{
		IUnknown* pUnk;
		if (pColl->get__NewEnum(&pUnk) == S_OK)
		{
			IEnumVARIANT* pEnum;
			pUnk->QueryInterface(IID_IEnumVARIANT, (void**)&pEnum);
			pUnk->Release();

			TTreeNode* pFile = TreeView->Items->Add(NULL, pName);
			TTreeNode* pMac = NULL;

			IMacPacket* pPacket;
			VARIANT v;
			HRESULT hr = S_OK;
			ULONG ulFetch;
			__int64 ftPrior(0);
			for (int i = 1; hr == S_OK; i++)
			{
				if (i % 20 == 0)
					DispCurrentPacketIndex(i, true);
				VariantInit(&v);
				hr = pEnum->Next(1, &v, &ulFetch);
				if (hr == S_OK)
				{
					char sz[64];
					TListItem* item = ListView->Items->Add();
					pPacket = (IMacPacket*)v.pdispVal;
					pPacket->AddRef();
					ListPacket->Add(pPacket);
					if (ListPacket->Capacity == ListPacket->Count)
						ListPacket->Capacity = ListPacket->Count + 64;

					__int64 ft;
					SYSTEMTIME st;
					pPacket->get_FileTime((CURRENCY*)&ft);
					ChangeFT(ft, st);
					wsprintf(sz, "%02d:%02d:%02d-%03d", st.wHour, st.wMinute, st.wSecond, st.wMilliseconds);
					item->Caption = sz;
					TStrings* ListItems = item->SubItems;
					sz[8] = '\0';
					TTreeNode* pNode;
					if (pMac == NULL)
					{
						pMac = pNode = TreeView->Items->AddChildObject(pFile, sz, (void*)(ListPacket->Count - 1));
					}
					else
					{
						pNode = TreeView->Items->AddObject(pMac, sz, (void*)(ListPacket->Count - 1));
					}
					if (i == 1)
					{
						ListItems->Add("0");
					}
					else
					{
						ftPrior = ft - ftPrior;
						ListItems->Add(itoa((int)(ftPrior / 10000), sz, 10));
					}
					ftPrior = ft;

					BSTR bstr;
					pPacket->get_DestMacString(&bstr);
					ListItems->Add(OleStrToString(bstr));
					SysFreeString(bstr);
					pPacket->get_SrcMacString(&bstr);
					ListItems->Add(OleStrToString(bstr));
					SysFreeString(bstr);

					long lEType, lSize;
					pPacket->get_EtherType_(&lEType);
					pPacket->get_Length(&lSize);
					if (lEType == ET_ARP || lEType == ET_RARP)
					{
						pPacket->get_SrcIPAddressString(&bstr);
						AnsiString as = OleStrToString(bstr);
						if (lEType == ET_ARP)
						{
							ListItems->Add("ARP");
							TreeView->Items->AddChildObject(pNode, "ARP from " + as, (void*)lEType);
						}
						else
						{
							ListItems->Add("RARP");
							TreeView->Items->AddChildObject(pNode, "RARP from " + as, (void*)lEType);
						}
						ListItems->Add(lSize);
						ListItems->Add(as);
						SysFreeString(bstr);
						pPacket->get_DestIPAddressString(&bstr);
						ListItems->Add(OleStrToString(bstr));
						SysFreeString(bstr);
					}
					else if (lEType == ET_IP)
					{
						short sProto;
						ListItems->Add("IP");
						ListItems->Add(lSize);
						pPacket->get_SrcIPAddressString(&bstr);
						AnsiString as = OleStrToString(bstr);
						ListItems->Add(as);
						SysFreeString(bstr);
						pPacket->get_DestIPAddressString(&bstr);
						ListItems->Add(OleStrToString(bstr));
						as = "IP (" + as + "-" + OleStrToString(bstr) + ")";
						pNode = TreeView->Items->AddChildObject(pNode, as, (void*)lEType);
						SysFreeString(bstr);
						pPacket->get_InternetProtocolString(&bstr);
						as = OleStrToString(bstr);
						SysFreeString(bstr);
						pPacket->get_InternetProtocol(&sProto);
						VARIANT vData;
						VariantInit(&vData);
						if (pPacket->get_Value(&vData) == S_OK && vData.vt == (VT_ARRAY | VT_UI1))
						{
							SafeArrayLock(vData.parray);
							LPBYTE pb = (LPBYTE)vData.parray->pvData;
							pb += MAC_HLEN;
							pb += (*pb & 0x0f) * sizeof(long);
							switch (sProto)
							{
							case ICMP:
								as += " (";
								as += GetICMPTypeName(*pb);
								as += ")";
								break;
							case UDP:
								as += " (" + GetUDPInfo(pb) + ")";
								break;
							case TCP:
								as += " (" + GetTCPInfo(pb) + ")";
								break;
							case OSPFIGP:
								as += " (" + GetOSPFInfo(pb) + ")";
								break;
							default:
								break;
							}
							SafeArrayUnlock(vData.parray);
							VariantClear(&vData);
						}
						ListItems->Add(as);
						TreeView->Items->AddChildObject(pNode, as, (void*)sProto);
					}
					else
					{
						pPacket->get_EtherTypeString(&bstr);
						ListItems->Add(OleStrToString(bstr));
						ListItems->Add(lSize);
						TreeView->Items->AddChildObject(pNode, OleStrToString(bstr), (void*)lEType);
						SysFreeString(bstr);
					}
					VariantClear(&v);
				}
			}
			pEnum->Release();
			char sz[24];
			wsprintf(sz, "Packets: %d", ListPacket->Count);
			StatusLine->Panels->Items[SL_STAT]->Text = sz;
			if (ListPacket->Count > 0)
			{
				SaveButton->Enabled = true;
				FileSaveAsItem->Enabled = true;
				if (TreeView->Visible)
					ChangeExpandButtons(true);
			}
		}
		pColl->Release();
	}
	TreeView->Items->EndUpdate();
	ListView->Items->EndUpdate();
	OpenButton->Enabled = true;
	NoUpdate = false;
}
//----------------------------------------------------------------------------
void TMainForm::ChangeMoveButtons(bool f)
{
	ListUpButton->Enabled = f;
	ListDownButton->Enabled = f;
	if (f && TreeView->Visible && ListView->Visible)
		SyncButton->Enabled = f;
}
//----------------------------------------------------------------------------
void TMainForm::ChangeDumpButtons(bool f)
{
	if (CopyButton->Enabled != f)
	{
		CopyButton->Enabled = f;
		EditCopyItem->Enabled = f;
		FilePrintItem->Enabled = f;
		PrintButton->Enabled = f;
	}
}
//----------------------------------------------------------------------------
void TMainForm::InitNew()
{
	NoUpdate = true;
	DumpView->Clear();
	StatusLine->Panels->Items[SL_STAT]->Text = "Initializing...";

	ListView->Items->BeginUpdate();
	ListView->Items->Clear();
	ListView->Items->EndUpdate();

	TreeView->Items->BeginUpdate();
	TreeView->Items->Clear();
	TreeView->Items->EndUpdate();

	ClearList();
	DumpList->Clear();
	SaveButton->Enabled = false;
	FileSaveAsItem->Enabled = false;
	OpenButton->Enabled = false;
	ChangeDumpButtons(false);
	ChangeMoveButtons(false);
	ChangeExpandButtons(false);
	NoUpdate = false;
}
//----------------------------------------------------------------------------
void TMainForm::ClearList()
{
	for (int i = 0; i < ListPacket->Count; i++)
	{
		IUnknown* pUnk = (IUnknown*)ListPacket->Items[i];
		if (pUnk) pUnk->Release();
	}
	ListPacket->Clear();
	ListPacket->Capacity = 16;
}
//----------------------------------------------------------------------------
void TMainForm::DumpData(LPBYTE pb, int len, int offset)
{
	TStrings* ss = DumpList;
	char sz[384];
	while (len)
	{
		int n = wsprintf(sz, "%04X(%4d)  ", offset, offset);
		int lensave = len;
		LPBYTE pbsave = pb;
		for (int i = 0; i < DumpWidth; i++)
		{
			if (len >= 4)
			{
				n += wsprintf(&sz[n], "%02X%02X%02X%02X ", *pb, *(pb + 1), *(pb + 2), *(pb + 3));
				len -= 4;
				pb += 4;
			}
			else if (len > 0)
			{
				for (int i = 0; i < 4; i++)
				{
					if (i < len)
					{
						n += wsprintf(&sz[n], "%02X", *(pb + i));
					}
					else
					{
						sz[n] = sz[n + 1] = ' ';
						n += 2;
					}
				}
				sz[n++] = ' ';
				len = 0;
			}
			else
			{
				memset(&sz[n], ' ', 9);
				n += 9;
			}
		}
		pb = pbsave;
		len = lensave;
		sz[n++] = ' ';
		int max = DumpWidth * 4;
		if (max > len) max = len;
		for (int i = 0; i < max; i++)
		{
			sz[n + i] = (isgraph(*(pb + i))) ? *(pb + i) : ((isspace(*(pb + i))) ? ' ' : '.');
		}
		sz[n + max] = '\0';
		ss->Append(sz);
		if (len <= max) break;
		offset += max;
		pb += max;
		len -= max;
	}
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::TreeViewChange(TObject *Sender, TTreeNode *Node)
{
	if (NoUpdate) return;
	if (TreeLastSelected == Node) return;

	TreeLastSelected = Node;

	DumpList->Clear();
	if (Node->Level == 0)	// Top Level = FILE
	{
		DispCurrentPacketIndex(-1);
		PrintFileInfo(Node);
		DumpView->Lines->BeginUpdate();
		DumpView->Text = DumpList->Text;
		DumpView->Lines->EndUpdate();
	}
	else
	{
		TTreeNode* pMac, *pProto, *pIP;
		pIP = NULL;

		DumpList->Clear();
		if (Node->Level == 1) // MAC Level
		{
			pMac = Node;
			pProto = Node->Item[0];
		}
		else if (Node->Level == 2)
		{
			pMac = Node->Parent;
			pProto = Node;
		}
		else if (Node->Level == 3)
		{
			pMac = Node->Parent->Parent;
			pProto = Node->Parent;
			pIP = Node;
		}
		if (pIP == NULL)
		{
			if (pProto->HasChildren)
				pIP = pProto->Item[0];
		}
		DispCurrentPacketIndex((int)pMac->Data);

		IMacPacket* pPacket = (IMacPacket*)ListPacket->Items[(int)pMac->Data];
		if (pPacket)
		{
			VARIANT v;
			VariantInit(&v);
			if (pPacket->get_Value(&v) == S_OK && v.vt == (VT_ARRAY | VT_UI1))
			{
				SafeArrayLock(v.parray);

				int nScroll(0);
				DumpView->Lines->BeginUpdate();
				DumpView->Clear();
				PrintMACInfo(pPacket, v.parray);
				DumpView->SelStart = 0;
				DumpView->SelAttributes->Color = Color[COLOR_MACH];
				DumpView->SetSelTextBuf(DumpList->Text.c_str());

				DumpView->SelStart = DumpList->Text.Length();
				if (Node->Level == 2)
					nScroll = DumpView->Lines->Count;

				DumpList->Clear();
				PrintPacketLevel(pPacket, v.parray);
				DumpView->SelAttributes->Color = Color[COLOR_PROTO];
				DumpView->SetSelTextBuf(DumpList->Text.c_str());

				DumpList->Clear();
				if (pIP)
				{
					if (Node->Level == 3)
						nScroll = DumpView->Lines->Count;
					int rest(0);
					LPBYTE pbRest;
					PrintIPLevel(pPacket, v.parray, rest, pbRest);
					DumpView->SelAttributes->Color = Color[COLOR_IP];
					DumpView->SetSelTextBuf(DumpList->Text.c_str());
					if (rest)
					{
						char sz[64];
						DumpList->Clear();
						wsprintf(sz, "User Data: (%dbytes)", rest);
						DumpList->Append(sz);
						DumpData(pbRest, rest, 0);
						DumpView->SelAttributes->Color = Color[COLOR_DUMP];
						DumpView->SetSelTextBuf(DumpList->Text.c_str());
					}
				}
				SafeArrayUnlock(v.parray);
				if (nScroll)
					while (nScroll--)
						SendMessage(DumpView->Handle, WM_VSCROLL, MAKEWPARAM(SB_LINEDOWN, 1), 0);
				DumpView->Lines->EndUpdate();
			}
			VariantClear(&v);
		}
	}
}
//---------------------------------------------------------------------------
void TMainForm::ChangeFT(__int64& ft, SYSTEMTIME& st)
{
	// cut incorrect micro sec info.
	ft /= 10000;
	ft *= 10000;
	FILETIME ftime;
	FileTimeToLocalFileTime((FILETIME*)&ft, &ftime);
	FileTimeToSystemTime(&ftime, &st);
}
//---------------------------------------------------------------------------
void TMainForm::PrintMACInfo(IMacPacket* pPacket, SAFEARRAY* parray)
{
	char sz[128];

	__int64 ft;
	pPacket->get_FileTime((CURRENCY*)&ft);
	SYSTEMTIME st;
	ChangeFT(ft, st);
	wsprintf(sz, "Time = %02d:%02d:%02d-%03d  Length = %d", st.wHour, st.wMinute, st.wSecond, st.wMilliseconds, parray->rgsabound[0].cElements);
	DumpList->Append(sz);

	BSTR bstr;
	AnsiString as;
	VARIANT_BOOL bMulticast;
	LPBYTE pb = (LPBYTE)parray->pvData;
	wsprintf(sz, "MAC: Destination Address: %02X-%02X-%02X-%02X-%02X-%02X",
		*pb, *(pb + 1), *(pb + 2), *(pb + 3), *(pb + 4), *(pb + 5));
	DumpList->Append(sz);
	if (pPacket->get_IsMulticast(&bMulticast) == S_OK && bMulticast != VARIANT_FALSE)
	{
		as = "MAC:                     Multicast address";
	}
	else
	{
		as = "MAC:                     ";
	}
	if (pPacket->get_DestVendorString(&bstr) == S_OK)
	{
		as += "(" + OleStrToString(bstr) + ")";
		SysFreeString(bstr);
	}
	DumpList->Append(as);
	wsprintf(sz, "MAC:      Source Address: %02X-%02X-%02X-%02X-%02X-%02X",
			*(pb + 6), *(pb + 7), *(pb + 8), *(pb + 9), *(pb + 10), *(pb + 11));
	DumpList->Append(sz);
	if (pPacket->get_SrcVendorString(&bstr) == S_OK)
	{
		as = "MAC:                     (" + OleStrToString(bstr) + ")";
		DumpList->Append(as);
		SysFreeString(bstr);
	}
	wsprintf(sz, "MAC:       Ethernet Type: %04X", ntohs(pb + 12));
	DumpList->Append(sz);
	if (pPacket->get_EtherTypeString(&bstr) == S_OK)
	{
		as = "MAC:                     (" + OleStrToString(bstr) + ")";
		SysFreeString(bstr);
	}
	else
		as = "MAC:                     (Unknown)";
	DumpList->Append(as);
}
//---------------------------------------------------------------------------
void TMainForm::PrintPacketLevel(IMacPacket* pPacket, SAFEARRAY* parray)
{
	long lProto;
	pPacket->get_EtherType_(&lProto);
	switch (lProto)
	{
	case ET_IP:
		PrintIPHeader(((LPBYTE)parray->pvData) + MAC_HLEN, pPacket);
		break;
	case ET_RARP:
	case ET_ARP:
		PrintARP(((LPBYTE)parray->pvData) + MAC_HLEN, pPacket);
		break;
	default:
		DumpData((LPBYTE)parray->pvData + MAC_HLEN, parray->rgsabound[0].cElements - MAC_HLEN, 0);
		break;
	}
}
//---------------------------------------------------------------------------
void TMainForm::PrintIPLevel(IMacPacket* pPacket, SAFEARRAY* parray, int& rest, LPBYTE& pbRest)
{
	short sProto;
	pPacket->get_InternetProtocol(&sProto);
	AnsiString as;
	LPBYTE pb = (LPBYTE)parray->pvData;
	pb += MAC_HLEN;
	int hlen = (*pb & 0x0f) * sizeof(long);
	int dlen = ntohs(pb + 2) - hlen;
	pb += hlen;	// Skip IP Header

	switch (sProto)
	{
	case UDP:
		hlen = PrintUDP(DumpList, pb, dlen);
		break;
	case TCP:
		hlen = PrintTCP(DumpList, pb, dlen);
		break;
	case ICMP:
		hlen = PrintICMP(DumpList, pb, dlen);
		break;
	case OSPFIGP:
		hlen = PrintOSPF(DumpList, pb, dlen);
		break;
	default:
		hlen = 0;
		break;
	}
	rest = dlen - hlen;
	pbRest = pb + hlen;
}
//---------------------------------------------------------------------------
void TMainForm::PrintFileInfo(TTreeNode*)
{
	IStream* pStream = NULL;
	if (MacCapture->QueryInterface(IID_IStream, (void**)&pStream) == S_OK && pStream)
	{
		STATSTG stat;
		char sz[32];
		ZeroMemory(&stat, sizeof(STATSTG));
		pStream->Stat(&stat, STATFLAG_NONAME);
		wsprintf(sz, "Capture size: %d bytes, %d packtes", stat.cbSize.u.LowPart, ListPacket->Count);
		DumpList->Append(sz);
		pStream->Release();
	}
}
//---------------------------------------------------------------------------
void TMainForm::PrintIPHeader(LPBYTE pb, IMacPacket* pPacket)
{
	char sz[128];
	TStrings* ss = DumpList;
	int hlen = *pb & 0x0f;
	int tlen = ntohs(pb + 2);
	wsprintf(sz, "IP: Version: %d, Header Length: %2d, Total Length: %4d",
		*pb >> 4, hlen * sizeof(long), tlen);
	ss->Append(sz);
	ss->Append("IP: Service Type:");
	BYTE b = *(pb + 1);
	wsprintf(sz, "IP:         Precedence: %d\r\nIP:", (b >> 5));
	ss->Append(sz);
	wsprintf(sz, "IP:              Delay: %d", ((b >> 4) & 1));
	ss->Append(sz);
	wsprintf(sz, "IP:         Throughput: %d", ((b >> 3) & 1));
	ss->Append(sz);
	wsprintf(sz, "IP:        Reliablitiy: %d", ((b >> 2) & 1));
	ss->Append(sz);
	wsprintf(sz, "IP:           Low-cost: %d", ((b >> 1) & 1));
	ss->Append(sz);
	ss->Append("IP:\r\nIP: Flagmentation Control:");
	b = *(pb + 6);
	wsprintf(sz, "IP:       Identification: 0x%02X",	ntohs(pb + 4));
	ss->Append(sz);
	wsprintf(sz, "IP:        ( reserved )   bit: %d", (b >> 7) & 1);
	ss->Append(sz);
	wsprintf(sz, "IP:       do not fragment bit: %d", (b >> 6) & 1);
	ss->Append(sz);
	wsprintf(sz, "IP:        more fragments bit: %d", (b >> 5) & 1);
	ss->Append(sz);
	wsprintf(sz, "IP:       Fragment Offset: %d\r\nIP:", ((b & 0x1F) * 256 + *(pb + 7)) * 8);
	ss->Append(sz);
	BSTR bstr;
	if (pPacket->get_InternetProtocolString(&bstr) != S_OK)
		bstr = SysAllocString(L"");
	wsprintf(sz, "IP: Time To Live: %d (Seconds/Hops)\r\nIP: Protocol: 0x%02X(%s)\r\nIP: Header Checksum: %d",
		*(pb + 8), *(pb + 9), OleStrToString(bstr).c_str(), ntohs(pb + 10));
	ss->Append(sz);
	SysFreeString(bstr);
	wsprintf(sz, "IP:      Source Address = %d.%d.%d.%d",
		*(pb + 12), *(pb + 13), *(pb + 14), *(pb + 15));
	ss->Append(sz);
	wsprintf(sz, "IP: Destination Address = %d.%d.%d.%d",
		*(pb + 16), *(pb + 17), *(pb + 18), *(pb + 19));
	ss->Append(sz);
	if ((hlen - 5) != 0)
	{
		ss->Append("IP: Options Data");
		DumpData(pb + 20, (hlen - 5) * sizeof(long), 20);
	}
}
//---------------------------------------------------------------------------
void TMainForm::PrintARP(LPBYTE pb, IMacPacket*)
{
	TStrings* ss = DumpList;
	char sz[128];
	wsprintf(sz, "ARP: Hardware Type: %04X, Protocol Type: %04X", ntohs(pb), ntohs(pb + 2));
	ss->Append(sz);
	wsprintf(sz, "ARP: Hardware Length = %d, Protocol Length = %d\r\nARP: Operation = ", *(pb + 4), *(pb + 5));
	static const char* aszArpOpe[] = {
		"Unknown Operation",
		"ARP request", "ARP response",
		"RARP request", "RARP response",
		"Dynamic RARP request", "Dynamic RARP reply",
		"Dynamic RARP error",
		"InARP request", "InARP resply",
	};
	int n = ntohs(pb + 6);
	if (n >= COUNTOF(aszArpOpe))
		n = 0;
	lstrcat(sz, aszArpOpe[n]);
	ss->Append(sz);
	wsprintf(sz, "ARP: Sender HA = %02X-%02X-%02X-%02X-%02X-%02X",
		*(pb + 8), *(pb + 9), *(pb + 10), *(pb + 11), *(pb + 12), *(pb + 13));
	ss->Append(sz);
	wsprintf(sz, "ARP: Sender IP = %d.%d.%d.%d", *(pb + 14), *(pb + 15), *(pb + 16), *(pb + 17));
	ss->Append(sz);
	wsprintf(sz, "ARP: Target HA = %02X-%02X-%02X-%02X-%02X-%02X",
		*(pb + 18), *(pb + 19), *(pb + 20), *(pb + 21), *(pb + 22), *(pb + 23));
	ss->Append(sz);
	wsprintf(sz, "ARP: Target IP = %d.%d.%d.%d", *(pb + 24), *(pb + 25), *(pb + 26), *(pb + 27));
	ss->Append(sz);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TreeViewEnter(TObject *Sender)
{
	if (TreeView && TreeView->Selected)
	{
		LastFocused = TreeView;
		TreeLastSelected = NULL;
		TreeViewChange(Sender, TreeView->Selected);
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DumpViewChange(TObject *Sender)
{
	bool b = (DumpView->Lines->Count > 0) ? true : false;
	ChangeDumpButtons(b);
}
//---------------------------------------------------------------------------
void TMainForm::ChangeExpandButtons(bool f)
{
	FullExpandItem->Enabled = f;
	EtherTypeExpandItem->Enabled = f;
	FullCollapseItem->Enabled = f;
	CollapseButton->Enabled = f;
	ExpandButton->Enabled = f;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DispTreeItemClick(TObject *Sender)
{
	SetVisible(DispTreeItem, TreeView);
	bool f = TreeView->Visible;
	ChangeExpandButtons(f);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::DispListItemClick(TObject *Sender)
{
	SetVisible(DispListItem, ListView);
}
//---------------------------------------------------------------------------
void TMainForm::SetVisible(TMenuItem* pItem, TControl* pControl)
{
	if (pControl->Visible == false)
	{
		pControl->Show();
		pItem->Checked = true;
	}
	else
	{
		pControl->Hide();
		pItem->Checked = false;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FullExpandItemClick(TObject *Sender)
{
	TreeView->Items->BeginUpdate();
	TTreeNode* p = TreeView->TopItem;
	TreeView->FullExpand();
	TreeView->TopItem = p;
	TreeView->Items->EndUpdate();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::EtherTypeExpandItemClick(TObject *Sender)
{
	TreeView->Items->BeginUpdate();
	TTreeNode* p = TreeView->TopItem;
	TTreeNodes* parent = TreeView->Items;
	parent->Item[0]->Expand(false);
	for (int i = 1; i < parent->Count; i++)
	{
		if (parent->Item[i]->Level == 1)
			parent->Item[i]->Expand(false);
	}
	TreeView->TopItem = p;
	TreeView->Items->EndUpdate();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ListViewEnter(TObject *Sender)
{
	if (ListView && ListView->Selected)
	{
		LastFocused = ListView;
		ListLastSelected = -1;
		ListViewChange(Sender, ListView->Selected, ctState);
	}
}
//---------------------------------------------------------------------------
void TMainForm::DispCurrentPacketIndex(int i, bool Reading)
{
	char sz[32];
	if (Reading)
		wsprintf(sz, "Reading...%d/%d", i, Packets);
	else
		wsprintf(sz, "Packets: %d/%d", i + 1, ListPacket->Count);
	StatusLine->Panels->Items[SL_STAT]->Text = sz;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ListViewChange(TObject *Sender, TListItem *item,
	  TItemChange Change)
{
	if (NoUpdate) return;
	if (ListLastSelected == item->Index) return;
	if (Change == ctState && ListPacket->Count > item->Index)
	{
		DumpList->Clear();

		ListLastSelected = item->Index;
		DispCurrentPacketIndex(item->Index);
		IMacPacket* pPacket = (IMacPacket*)ListPacket->Items[item->Index];
		if (pPacket)
		{
			VARIANT v;
			VariantInit(&v);
			if (pPacket->get_Value(&v) == S_OK && v.vt == (VT_ARRAY | VT_UI1))
			{
				long EType;
				pPacket->get_EtherType_(&EType);
				SafeArrayLock(v.parray);
				LPBYTE pb = (LPBYTE)v.parray->pvData;
				int len = v.parray->rgsabound[0].cElements;
				DumpList->Append("MAC Header:");
				DumpData(pb, MAC_HLEN, 0);
				pb += MAC_HLEN;
				len -= MAC_HLEN;
				if (EType == ET_IP)
				{
					int hlen = (*pb & 0x0f) * sizeof(long);
					BYTE proto = *(pb + 9);
					DumpList->Append("\r\nIP Header:");
					DumpData(pb, hlen, 0);
					pb += hlen;
					len -= hlen;
					if (len > 0)
					{
						switch (proto)
						{
						case TCP:
							hlen = (*(pb + 12) >> 4) * sizeof(long);
							DumpList->Append("\r\nTCP Header:");
							break;
						case UDP:
							hlen = 8;
							DumpList->Append("\r\nUDP Header:");
							break;
						case OSPFIGP:
							hlen = 24;
							DumpList->Append("\r\nOSPF Header:");
							break;
						default:
							hlen = 0;
							break;
						}
						if (hlen)
						{
							DumpData(pb, hlen, 0);
							len -= hlen;
							pb += hlen;
						}
						if (len > 0)
						{
							DumpList->Append("\r\nData");
							DumpData(pb, len, 0);
						}
					}
				}
				else
				{
					DumpList->Append("\r\nData:");
					DumpData(pb, len, 0);
				}
				SafeArrayUnlock(v.parray);
				VariantClear(&v);
			}
		}
		NoUpdate = true;
		DumpView->Lines->BeginUpdate();
		DumpView->Clear();
		DumpView->SelStart = 0;
		DumpView->SelAttributes->Color = Color[COLOR_DUMP];
		DumpView->Paragraph->Numbering = nsNone;
		DumpView->Text = DumpList->Text;
		DumpView->Lines->EndUpdate();
		NoUpdate = false;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SpeedBarResize(TObject *Sender)
{
	AboutButton->Left = SpeedBar->Width - (AboutButton->Width + 8);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FullCollapseItemClick(TObject *Sender)
{
	TreeView->FullCollapse();
}
//---------------------------------------------------------------------------
void TMainForm::StopEvent(long ResultCode)
{
	char sz[128];
	wsprintf(sz, "Capture Stopped %08X(%d)", ResultCode, ResultCode);
	Application->MessageBox(sz, "FreeCap", MB_OK);
}
//---------------------------------------------------------------------------
void TMainForm::MonitorEvent(long aTick, long aPackets, long aBytes, VARIANT_BOOL* pStop)
{
	*pStop = (MonPackForm->GetAbort()) ? VARIANT_TRUE : VARIANT_FALSE;
	if ((ULONG)TicksCount >= COUNTOF(ATicks))
	{
		TicksCount = 0;
	}
	if (ATicks[TicksCount])
	{
		MonPackForm->Chart->Series[0]->Delete(0);
//		MonPackForm->Chart->Series[1]->Delete(0);
		MonPackForm->Chart->BottomAxis->Maximum = Ticks;
		MonPackForm->Chart->BottomAxis->Minimum = ATicks[TicksCount];
	}
	MonPackForm->Chart->Series[0]->AddXY(Ticks, aPackets, "", clTeeColor);
//	MonPackForm->Chart->Series[1]->AddXY(Ticks, aBytes, "", clTeeColor);
	Ticks += aTick;
	ATicks[TicksCount] = Ticks;
	TicksCount++;
	Packets += aPackets;
	Bytes += aBytes;
	char sz[64];
	wsprintf(sz, "%d packets, %d bytes captured", Packets, Bytes);
//	StatusLine->Panels->Items[SL_STAT]->Text = sz;
	MonPackForm->PacketsLabel->Caption = sz;
}
//---------------------------------------------------------------------------
HRESULT STDMETHODCALLTYPE DMacCaptureEvent::Invoke(
			/* [in] */ DISPID dispIdMember,
			/* [in] */ REFIID riid,
			/* [in] */ LCID lcid,
			/* [in] */ WORD wFlags,
			/* [out][in] */ DISPPARAMS __RPC_FAR *pDispParams,
			/* [out] */ VARIANT __RPC_FAR *pVarResult,
			/* [out] */ EXCEPINFO __RPC_FAR *pExcepInfo,
			/* [out] */ UINT __RPC_FAR *puArgErr)
{
	if (Parent == NULL) return S_OK;
	VARIANTARG* pArg = pDispParams->rgvarg;
	switch (dispIdMember)
	{
	case 1:   // void Stop(long ReasonCode);
		Parent->StopEvent(pArg->lVal);
		break;
	case 2:	  // void RecvData(IMacPacket* pData, VARIANT_BOOL* pStop);
		// never
		break;
	case 3:	  // void MonitorEvent(long Tick, long Packets, long Bytes, VARIANT_BOOL* pSTop);
		Parent->MonitorEvent((pArg + 3)->lVal, (pArg + 2)->lVal, (pArg + 1)->lVal, pArg->pboolVal);
		break;
	default:
		return DISP_E_MEMBERNOTFOUND;
	}
	return S_OK;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::OptionSetItemClick(TObject *Sender)
{
	bool redraw(false);
	Application->CreateForm(__classid(TOptionSetDlg), &OptionSetDlg);
	OptionSetDlg->BuffUpDn->Position = (short)(ParamBuffSize / (1024 * 1024));
	OptionSetDlg->IntervalUpDn->Position = (short)ParamInterval;
	OptionSetDlg->DumpUpDn->Position = (short)DumpWidth;
	if (OptionSetDlg->ShowModal() == IDOK)
	{
		ParamInterval = OptionSetDlg->IntervalUpDn->Position;
		ParamBuffSize = OptionSetDlg->BuffUpDn->Position;
		int old = DumpWidth;
		DumpWidth = OptionSetDlg->DumpUpDn->Position;
		if (DumpWidth != old)
			redraw = true;
		TRegistry* reg = new TRegistry;
		if (reg->OpenKey("Software\\arton\\FreeCap", true))
		{
			try
			{
				reg->WriteInteger("Interval", ParamInterval);
				reg->WriteInteger("BufferSize", ParamBuffSize);
				reg->WriteInteger("DumpWidth", DumpWidth);
				ParamBuffSize *= 1024 * 1024;
			}
			catch (TObject* p)
			{
				;
			}
			reg->CloseKey();
		}
		delete reg;
		MacCapture->set_BufferSize(ParamBuffSize);
		MacCapture->set_MonitorEventInterval(ParamInterval);
	}
	delete OptionSetDlg;

	if (redraw)
	{
		if (TreeView->Focused())
		{
			TreeViewEnter(Sender);
		}
		else if (ListView->Focused())
		{
			ListViewEnter(Sender);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StatusLineResize(TObject *Sender)
{
	int w(0);
	for (int i = 1; i < StatusLine->Panels->Count; i++)
		w += StatusLine->Panels->Items[i]->Width;
	StatusLine->Panels->Items[0]->Width = (StatusLine->Width > w) ? StatusLine->Width - w : 0;
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::ListUpButtonClick(TObject *Sender)
{
	if (ListView->Focused())
	{
		MoveList(true);
	}
	else if (TreeView->Focused())
	{
		MoveTree(true, TreeView->Selected);
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ListDownButtonClick(TObject *Sender)
{
	if (ListView->Focused())
	{
		MoveList(false);
	}
	else if (TreeView->Focused())
	{
		MoveTree(false, TreeView->Selected);
	}
	else
	{
		if (ListView->Visible)
		{
			if (ListView->Selected == NULL)
				ListView->Selected = ListView->TopItem;
			MoveList(false);
		}
		else if (TreeView->Visible)
		{
			MoveTree(false, NULL);
		}
	}
}
//---------------------------------------------------------------------------
void TMainForm::MoveTree(bool Up, TTreeNode* node)
{
	if (node == NULL)
		node = TreeView->TopItem;
	if (node)
	{
		TTreeNode* next = (Up) ? node->GetPrev() : node->GetNext();
		if (node->Level > 0)
		{
			while (next && next->Level != node->Level)
			{
				next = (Up) ? next->GetPrev() : next->GetNext();
			}
		}
		if (next)
		{
			next->Focused = true;
			TreeView->Selected = next;
			next->MakeVisible();
		}
	}
}
//---------------------------------------------------------------------------
void TMainForm::MoveList(bool Up)
{
	TListItem* item = ListView->Selected;
	if (item)
	{
		TItemStates s;
		s << isNone;
		item = ListView->GetNextItem(item, (Up) ? sdAbove : sdBelow, s);
		if (item)
		{
			ListView->ItemFocused = item;
			ListView->Selected = item;
			item->MakeVisible(true);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SyncButtonClick(TObject *Sender)
{
	TListItem* item;
	TTreeNode* node;
	if (ListView->Focused())
	{
		item = ListView->Selected;
		if (item)
		{
			int idx = ListView->Items->IndexOf(item);
			if (idx >= 0)
			{
				node = (TreeView->Items->GetFirstNode())->Item[idx];
				if (node)
				{
					node->Focused = true;
					TreeView->Selected = node;
					node->MakeVisible();
					TreeView->SetFocus();
				}
			}
		}
	}
	else if (TreeView->Focused())
	{
		node = TreeView->Selected;
		if (node)
		{
			if (node->Level == 3)
				node = node->Parent;
			if (node->Level == 2)
				node = node->Parent;
			if (node->Level == 1)
			{
				item = ListView->Items->Item[(int)node->Data];
				if (item)
				{
					ListView->ItemFocused = item;
					ListView->Selected = item;
					item->MakeVisible(true);
					ListView->SetFocus();
				}
			}
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Font1Click(TObject *Sender)
{
	TFont* p = new TFont;
	p->Assign(DumpView->Font);
	FontDialog->Font = p;
	if (FontDialog->Execute())
	{
		DumpView->Font = FontDialog->Font;
		TRegistry* reg = new TRegistry;
		if (reg->OpenKey("Software\\arton\\FreeCap\\Font", true))
		{
			TFont* pNew = FontDialog->Font;
			try
			{
				reg->WriteInteger("Height", pNew->Height);
				reg->WriteString("Name", pNew->Name);
				reg->WriteInteger("Pitch", pNew->Pitch);
				reg->WriteInteger("Size", pNew->Size);
			}
			catch (TObject* p)
			{
				;
			}
			reg->CloseKey();
		}
		delete reg;
	}
	else
	{
		DumpView->Font = p;
	}
	delete p;
	if (LastFocused == ListView)
	{
		ListViewEnter(Sender);
	}
	else
	{
		TreeViewEnter(Sender);
	}
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FontDialogApply(TObject *Sender, HWND Wnd)
{
	DumpView->Font = FontDialog->Font;
	if (LastFocused == ListView)
	{
		ListViewEnter(Sender);
	}
	else
	{
		TreeViewEnter(Sender);
	}
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::Color1Click(TObject *Sender)
{
	Application->CreateForm(__classid(TColorSettingDlg), &ColorSettingDlg);
	for (int i = 0; i < COLOR_MAX; i++)
		ColorSettingDlg->SetColor(i, Color[i]);
	if (ColorSettingDlg->ShowModal() == mrOk)
	{
		for (int i = 0; i < COLOR_MAX; i++)
			Color[i] = ColorSettingDlg->GetColor(i);

		static char* asValName[] = { "Dump", "MACH", "PROTO", "IP", };
		TRegistry* reg = new TRegistry;
		if (reg->OpenKey("Software\\arton\\FreeCap\\Color", true))
		{
			try
			{
				for (int i = 0; i < COLOR_MAX; i++)
					reg->WriteInteger(asValName[i], Color[i]);
			}
			catch (TObject* p)
			{
				;
			}
			reg->CloseKey();
		}
		delete reg;
		if (TreeView->Focused())
		{
			TreeViewEnter(Sender);
		}
		else if (ListView->Focused())
		{
			ListViewEnter(Sender);
		}
	}
	delete ColorSettingDlg;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	CanClose = (Capturing) ? false : true;
}
//---------------------------------------------------------------------------


__fastcall TMainForm::~TMainForm()
{
    //TODO ̉ɃR[hǉĂ
	if (MacCapture)
	{
		ClearList();
		if (Capturing)
			MacCapture->Stop();
		MacCapture->Close();
		IConnectionPointContainer* pConnPt;
		if (MacCapture->QueryInterface(IID_IConnectionPointContainer, (void**)&pConnPt) == S_OK)
		{
			IConnectionPoint* pConn;
			if (pConnPt->FindConnectionPoint(DIID__IMacCaptureEvents, &pConn) == S_OK)
			{
				pConn->Unadvise(dwCookie);
				pConn->Release();
			}
			pConnPt->Release();
		}
		MacCapture->Release();
		MacCapture = NULL;
		CaptureEventRecver->Parent = NULL;
                delete CaptureEventRecver;
                CaptureEventRecver = NULL;
	}
	for (int i = 0; i < MacList->Count; i++)
	{
		((IUnknown*)MacList->Objects[i])->Release();
	}
	delete MacList;
	MacList = NULL;
	for (int i = 0; i < IPAddrList->Count; i++)
	{
		((IUnknown*)IPAddrList->Objects[i])->Release();
	}
	delete IPAddrList;
	IPAddrList = NULL;
	for (int i = 0; i < ProtList->Count; i++)
	{
		((IUnknown*)ProtList->Objects[i])->Release();
	}
	delete ProtList;
	ProtList = NULL;
	delete DumpList;
	DumpList = NULL;
// ListViewChanged will be called after here.
//	delete ListPacket;
//	ListPacket = NULL;
	TRegistry* reg = new TRegistry;
	if (reg->OpenKey("Software\\arton\\FreeCap", true))
	{
		try
		{
			reg->WriteInteger("FormLeft", Left);
			reg->WriteInteger("FormTop", Top);
			reg->WriteInteger("FormHeight", Height);
			reg->WriteInteger("FormWidth", Width);
			reg->WriteBool("ListView", ListView->Visible);
			reg->WriteInteger("ListViewHeight", ListView->Height);
			reg->WriteBool("TreeView", TreeView->Visible);
			reg->WriteInteger("TreeViewWidth", TreeView->Width);
			short asW[9];
			for (int i = 0; i < 9; i++)
			{
				asW[i] = (short)ListView->Columns->Items[i]->Width;
			}
			reg->WriteBinaryData("ListCols", asW, 9 * sizeof(short));
		}
		catch (TObject* p)
		{
			;
		}
		reg->CloseKey();
	}
	delete reg;

}

