// RFC1700.txt
#include "stdafx.h"

static LPCOLESTR protoes[] = {
  /* 0*/   L"Reserved", //Reserved                              [JBP]
  /* 1*/   L"ICMP",    //Internet Control Message       [RFC792,JBP]
  /* 2*/   L"IGMP",    // Internet Group Management     [RFC1112,JBP]
  /* 3*/   L"GGP",     // Gateway-to-Gateway              [RFC823,MB]
  /* 4*/   L"IP",     //  IP in IP (encasulation)               [JBP]
  /* 5*/   L"ST",     //  Stream                 [RFC1190,IEN119,JWF]
  /* 6*/   L"TCP",     // Transmission Control           [RFC793,JBP]
  /* 7*/   L"UCL",     // UCL                                    [PK]
  /* 8*/   L"EGP",     // Exterior Gateway Protocol     [RFC888,DLM1]
  /* 9*/   L"IGP",     // any private interior gateway          [JBP]
  /*10*/   L"BBN-RCC-MON", // BBN RCC Monitoring                    [SGC]
  /*11*/   L"NVP-II",  // Network Voice Protocol         [RFC741,SC3]
  /*12*/   L"PUP",     // PUP                             [PUP,XEROX]
  /*13*/   L"ARGUS",     //RGUS                                [RWS4]
  /*14*/   L"EMCON",     //MCON                                 [BN7]
  /*15*/   L"XNET",     //Cross Net Debugger            [IEN158,JFH2]
  /*16*/   L"CHAOS",     //haos                                 [NC3]
  /*17*/   L"UDP",     // User Datagram                  [RFC768,JBP]
  /*18*/   L"MUX",     // Multiplexing                    [IEN90,JBP]
  /*19*/   L"DCN-MEAS",// DCN Measurement Subsystems           [DLM1]
  /*20*/   L"HMP",     // Host Monitoring                [RFC869,RH6]
  /*21*/   L"PRM",     // Packet Radio Measurement              [ZSU]
  /*22*/   L"XNS-IDP", // XEROX NS IDP               [ETHERNET,XEROX]
  /*23*/   L"TRUNK-1", // Trunk-1                              [BWB6]
  /*24*/   L"TRUNK-2", // Trunk-2                              [BWB6]
  /*25*/   L"LEAF-1", //  Leaf-1                               [BWB6]
  /*26*/   L"LEAF-2", //  Leaf-2                               [BWB6]
  /*27*/   L"RDP",     // Reliable Data Protocol         [RFC908,RH6]
  /*28*/   L"IRTP",     //Internet Reliable Transaction  [RFC938,TXM]
  /*29*/   L"ISO-TP4", // ISO Transport Protocol Class 4 [RFC905,RC77]
  /*30*/   L"NETBLT",     //lk Data Transfer Protocol    [RFC969,DDC1]
  /*31*/   L"MFE-NSP", // MFE Network Services Protocol  [MFENET,BCH2]
  /*32*/   L"MERIT-INP", //ERIT Internodal Protocol             [HWB]
  /*33*/   L"SEP",     // Sequential Exchange Protocol        [JC120]
  /*34*/   L"3PC",     // Third Party Connect Protocol         [SAF3]
  /*35*/   L"IDPR",     //Inter-Domain Policy Routing Protocol [MXS1]
  /*36*/   L"XTP",     // XTP                                   [GXC]
  /*37*/   L"DDP",     // Datagram Delivery Protocol            [WXC]
  /*38*/   L"IDPR-CMTP", //DPR Control Message Transport Proto [MXS1]
  /*39*/   L"TP++",   // TP++ Transport Protocol               [DXF]
  /*40*/   L"IL",     //  IL Transport Protocol                [DXP2]
  /*41*/   L"SIP",     // Simple Internet Protocol              [SXD]
  /*42*/   L"SDRP",     //Source Demand Routing Protocol       [DXE1]
  /*43*/   L"SIP-SR", //  SIP Source Route                      [SXD]
  /*44*/   L"SIP-FRAG", //SIP Fragment                          [SXD]
  /*45*/   L"IDRP",     //Inter-Domain Routing Protocol   [Sue Hares]
  /*46*/   L"RSVP",     //Reservation Protocol           [Bob Braden]
  /*47*/   L"GRE",     // General Routing Encapsulation     [Tony Li]
  /*48*/   L"MHRP",     //Mobile Host Routing Protocol[David Johnson]
  /*49*/   L"BNA",     // BNA                          [Gary Salamon]
  /*50*/   L"SIPP-ESP", //SIPP Encap Security Payload [Steve Deering]
  /*51*/   L"SIPP-AH", // SIPP Authentication Header  [Steve Deering]
  /*52*/   L"I-NLSP", //  Integrated Net Layer Security  TUBA [GLENN]
  /*53*/   L"SWIPE",     //P with Encryption                    [JI6]
  /*54*/   L"NHRP",     //NBMA Next Hop Resolution Protocol
  /*55*/   L"Unassigned", // Unassigned                            [JBP]
  /*56*/   L"Unassigned", // Unassigned                            [JBP]
  /*57*/   L"Unassigned", // Unassigned                            [JBP]
  /*58*/   L"Unassigned", // Unassigned                            [JBP]
  /*59*/   L"Unassigned", // Unassigned                            [JBP]
  /*60*/   L"Unassigned", // 
  /*61*/   L"internal", // any host internal protocol            [JBP]
  /*62*/   L"CFTP",     //CFTP                            [CFTP,HCF2]
  /*63*/   L"local", // any local network                     [JBP]
  /*64*/   L"SAT-EXPAK", //ATNET and Backroom EXPAK             [SHB]
  /*65*/   L"KRYPTOLAN",   // Krolan                            [PXL1]
  /*66*/   L"RVD",     // MIT Remote Virtual Disk Protocol      [MBG]
  /*67*/   L"IPPC",     //Internet Pluribus Packet Core         [SHB]
  /*68*/   L"distributefile", // any distributed file system           [JBP]
  /*69*/   L"SAT-MON", // SATNET Monitoring                     [SHB]
  /*70*/   L"VISA",     //VISA Protocol                        [GXT1]
  /*71*/   L"IPCV",     //Internet Packet Core Utility          [SHB]
  /*72*/   L"CPNX",     //Computer Protocol Network Executive  [DXM2]
  /*73*/   L"CPHB",     //Computer Protocol Heart Beat         [DXM2]
  /*74*/   L"WSN",     // Wang Span Network                     [VXD]
  /*75*/   L"PVP",     // Packet Video Protocol                 [SC3]
  /*76*/   L"BR-SAT-MON", // Backroom SATNET Monitoring            [SHB]
  /*77*/   L"SUN-ND", //  SUN ND PROTOCOL-Temporary             [WM3]
  /*78*/   L"WB-MON", //  WIDEBAND Monitoring                   [SHB]
  /*79*/   L"WB-EXPAK", //WIDEBAND EXPAK                        [SHB]
  /*80*/   L"ISO-IP", //  ISO Internet Protocol                 [MTR]
  /*81*/   L"VMTP",     //VMTP                                 [DRC3]
  /*82*/   L"SECURE-VMTP", //URE-VMTP                          [DRC3]
  /*83*/   L"VINES",     //INES                                 [BXH]
  /*84*/   L"TTP",     // TTP                                   [JXS]
  /*85*/   L"NSFNET-IGP", //NSFNET-IGP                            [HWB]
  /*86*/   L"DGP",     // Dissimilar Gateway Protocol     [DGP,ML109]
  /*87*/   L"TCF",     // TCF                                  [GAL5]
  /*88*/   L"IGRP",     //IGRP                            [CISCO,GXS]
  /*89*/   L"OSPFIGP",     //FIGP                      [RFC1583,JTM4]
  /*90*/   L"Sprite-RPC", //rite RPC Protocol            [SPRITE,BXW]
  /*91*/   L"LARP",     //Locus Address Resolution Protocol     [BXH]
  /*92*/   L"MTP",     // Multicast Transport Protocol          [SXA]
  /*93*/   L"AX.25", //   AX.25 Frames                         [BK29]
  /*94*/   L"IPIP",     //IP-within-IP Encapsulation Protocol   [JI6]
  /*95*/   L"MICP",     //Mobile Internetworking Control Pro.   [JI6]
  /*96*/   L"SCC-SP", //  Semaphore Communications Sec. Pro.    [HXH]
  /*97*/   L"ETHERIP",     //ernet-within-IP Encapsulation     [RXH1]
  /*98*/   L"ENCAP",  // Encapsulation Header         [RFC1241,RXB3]
  /*99*/   L"encyption", // any private encryption scheme         [JBP]
  /*100*/   L"GMTP",     //GMTP                                 [RXB5]
};

#define ProtoNameTableSize (sizeof(protoes)/sizeof(protoes[0]))

int GetIPNameTableSize()
{
	return ProtoNameTableSize;
}

bool IsAssigned(BYTE b)
{
	if (!b || b >= ProtoNameTableSize) return false;
	if (wcscmp(L"Unassigned", protoes[b]) == 0) return false;
	return true;
}

LPCOLESTR GetProtoName(BYTE b)
{
	if (b >= ProtoNameTableSize) return L"Unassigned";
	return protoes[b];
}
