// Copyright(c) 1999 arton

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "MacCapv2.h"
#include "MacCapv2_i.c"

#include "NameValuePair.h"
#include "Vendors.h"
#include "EtherTypeNameCollection.h"
#include "ProtocolNameCollection.h"
#include "Adapters.h"
#include "FilterParam.h"
#include "MacCapture.h"
#include "MacMonitor.h"

CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_MacMonitor, CMacMonitor)
OBJECT_ENTRY(CLSID_MacCapture, CMacCapture)
OBJECT_ENTRY(CLSID_ProtocolNameCollection, CProtocolNameCollection)
OBJECT_ENTRY(CLSID_EtherTypeNameCollection, CEtherTypeNameCollection)
OBJECT_ENTRY(CLSID_VendorCollectionEx, CVendors)
OBJECT_ENTRY(CLSID_AdapterCollectionEx, CAdapters)
OBJECT_ENTRY(CLSID_VendorCollection, CVendors)
OBJECT_ENTRY(CLSID_FilterParam, CFilterParam)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
    if (dwReason == DLL_PROCESS_ATTACH)
    {
        _Module.Init(ObjectMap, hInstance, &LIBID_MACCAPV2Lib);
        DisableThreadLibraryCalls(hInstance);
    }
    else if (dwReason == DLL_PROCESS_DETACH)
        _Module.Term();
    return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////

STDAPI DllCanUnloadNow(void)
{
    return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////

STDAPI DllRegisterServer(void)
{
    return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////

STDAPI DllUnregisterServer(void)
{
    return _Module.UnregisterServer(TRUE);
}


